function [STRAINS SDEL]=gen_pivotMDS_strains(D,maxK)

    incr_amount = round(log10(size(D,1)));
    my_perm = randperm(size(D,1));
    k = 1;
    K = my_perm(1);
    upper_loop_bound = size(D,1);
    if nargin > 1
        upper_loop_bound = maxK;
    end
    STRAINS = zeros(1,length(incr_amount:incr_amount:upper_loop_bound));
    
    Sold = 0;
    for i = incr_amount:incr_amount:upper_loop_bound
        %[X V S] = pivotMDS(D,my_perm(1:i));
%         if( i > incr_amount )
%             [X V S K] = pivotMDS2(D,K,i,X(:,1));
%         else
            [X V S K Sprev] = pivotMDS2plus(D,K,i);
%         end
        I = repmat(K,size(D,1),1);
        I = [I(:) repmat((1:size(D,1))',length(K),1)];
        %STRAINS(k)=sparsestressfun(X(:),D,I);
        STRAINS(k)=S;
        SDEL(k)=(Sprev-Sold);
        Sold = S;
        k = k  + 1;
    end
        