function [I]=glimmer_pattern(I,P,k)

N=length(P);
offs_start = size(I,1)/N;
if offs_start == N
    return;
end
offs_end = min(N,offs_start + k);

I2 = zeros(N*offs_end,2);
I2(:,1)=reshape(repmat((1:N),offs_end,1),offs_end*N,1);
I2(repmat((1:offs_end)',N,1)<=offs_start,2)=I(:,2);
I=I2;

k=offs_end;
for i = 1:N
    for j = (offs_start+1):offs_end
        
        I(((i-1)*k)+j,1)=i;
        I(((i-1)*k)+j,2)=P(mod(P(i)+j,N)+1);
    end
end
