%
%   perform smacof for a given distance matrix and a given 2d config until
%
%   convergence to epsilon
function [X t s]=sparsesmacof(X,DELTA,I,eps,maxiter)
    
    fold = 1e100;
    [f g]=sparsestressfun(X(:),DELTA,I);
%     [f]=sparsestressfun(X(:),DELTA,I);
    t = 0;
    fprintf('%d: %f\n', t, f);
    while ((fold-f)/f) > eps && t < maxiter
        t = t + 1;
        fold = f;
        X(:) = X(:) - (1/(2*size(X,1)))*g;
%         X(:) = sparse_stress_major(X(:),DELTA,I);
        [f g]=sparsestressfun(X(:),DELTA,I);
%         [f]=sparsestressfun(X(:),DELTA,I);
        if mod(t,10) == 0
            fprintf('%d: %f\n', t, f);
        end
        s(t)=f;
        %f

%         scatter(X(:,1),X(:,2),'.');
%         drawnow
    end