function [STRAINS ITIMES FULLSTRAIN TOTALDISTS]=gen_pivotMDS_strains_manual(D)

    startoff = ceil(log10(size(D,1))); % number of pivots to start with
    my_perm = randperm(size(D,1));
    k = 1;
    K = my_perm(1);
    upper_loop_bound = size(D,1);

    incr_amount = ceil(log10(size(D,1)));
    for i = startoff:incr_amount:upper_loop_bound        
        
        TOTALDISTS = i;
        
        tic;
        [X V S K] = pivotMDS2plus_manual(D,K,i);
        close();
        if i > startoff
            [d_proc,Z,transf]=procrustes(Xold,X);
            X=X*transf.T;
            scatter(X(:,1),X(:,2));
        else
            scatter(X(:,1),X(:,2));
        end
        if ~isempty(input('Done? [N/y]','s'))
            FULLSTRAIN = fullstrain( X, D );
            break;
        end
        shg;
        drawnow
%         figure(gcf);
        Xold = X;
        STRAINS(k)=S;                
        
        ITIMES(k)=toc;
        k = k  + 1;
    end
